﻿Imports VB = Microsoft.VisualBasic
Public Class NIDCardMain
    'NID Card VB.net
    'V1.0.0.2081 For TDK Series DLL V2.21.7D+, support DLX
    'V1.0.0.2082 fix bug
    '....
    '....
    'V1.0.0.2091 Code clearing
    'V1.0.0.2092 Correct program name
    'V1.2.31.1   For Support RDNIDLib.dll v.2.31

    Private RetValue As Integer
    Private ReaderList() As String
    Private ReaderNum As Short
    Private CardObj As Integer
    Private ReaderNameString As String
    Private CardNIDNum As String
    Private AllCardData As String
    Private PhotoData As String
    Private ReadingFg As Boolean

    Private Const NID_CODE = 0   '1234567890123#
    Private Const Title_T = 1    'Thai title#
    Private Const Name_T = 2     'Thai name#
    Private Const MidName_T = 3  'Thai mid name#
    Private Const Surname_T = 4  'Thai surname#

    Private Const Title_E = 5    'Eng title#
    Private Const Name_E = 6     'Eng name#
    Private Const MidName_E = 7  'Eng mid name#
    Private Const Surname_E = 8  'Eng surname#

    Private Const Home_No = 9    '12/34#
    Private Const Moo = 10       '10#
    Private Const Trok = 11      'xxxx#
    Private Const Soi = 12       'xxxxx#
    Private Const Road = 13      'xx#
    Private Const Tumbon = 14    'xxxx#
    Private Const Amphoe = 15    'xxxxxxxx#
    Private Const Province = 16  'xxxxx#
    Private Const Gender = 17    '1=male,2=female

    Private Const Birth_Date = 18        '25xx08xx# YYYYMMDD
    Private Const Issue_Place = 19       'xxxxxxxxxxxxxx#
    Private Const Issue_Date = 20        '25xx10xx# issue date
    Private Const Expiry_Date = 21       '25xx08xx# expiry date
    Private Const Issue_Num = 22         '25xx08xx# expiry date

    Private Function _yyyymmdd_(ByRef strDate As String) As String
        Dim strRet As String
        Dim _yyyy As String = strDate.Substring(0, 4)
        Dim _mm As String = strDate.Substring(4, 2)
        Dim _dd As String = strDate.Substring(6, 2)

        Dim mm() As String = {"", "ม.ค.", "ก.พ.", "มี.ค.", "เม.ย.", "พ.ค.", "มิ.ย.", "ก.ค.", "ส.ค.", "ก.ย.", "ต.ค.", "พ.ย.", "ธ.ค."}
        Dim _tm As String

        If _mm = "00" Then
            _tm = "-"
        Else
            _tm = mm(Integer.Parse(_mm))
        End If

        If _yyyy = "0000" Then
            _yyyy = "-"
        End If

        If _dd = "00" Then
            _dd = "-"
        End If

        strRet = _dd + " " + _tm + " " + _yyyy

        _yyyymmdd_ = strRet
    End Function

    Public Function writeFile(ByRef FData As String, ByRef Fname As String) As Integer
        Dim FileNum As Integer
        FileNum = FreeFile()
        On Error GoTo WriteFileError
        FileOpen(FileNum, Fname, OpenMode.Binary)
        FilePut(FileNum, FData)
        FileClose(FileNum)
        writeFile = 0
        GoTo EndSub
WriteFileError:
        MessageBox.Show("Save buffer file error, write protected!" & vbCrLf & "(Please change the running folder or drive.)", ProductName)
        writeFile = -1
        Resume EndSub
EndSub:
    End Function

    Private Sub NIDCardMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Check DLL file
        Dim FFNameDLL As String
        Dim FFNameDLD As String
        Dim FileNum As Integer
        Dim MsgErr As String
        ReadingFg = False
        FileNum = FreeFile()
        FFNameDLL = Application.StartupPath & "\RDNIDLib.DLL"
        On Error GoTo NoDLLFile
        FileOpen(FileNum, FFNameDLL, OpenMode.Input)
        FileClose(FileNum)
        GoTo CheckDLD
NoDLLFile:
        MessageBox.Show("DLL file not found!" & vbCrLf & FFNameDLL, ProductName)
        End

        'Check DLX file
CheckDLD:
        FileNum = FreeFile()
        FFNameDLD = Application.StartupPath & "\RDNIDLib.DLX"
        On Error GoTo NoDLDFile
        FileOpen(FileNum, FFNameDLD, OpenMode.Input)
        FileClose(FileNum)
        GoTo StartProg
NoDLDFile:
        MessageBox.Show("DLX file not found!" & vbCrLf & FFNameDLD, ProductName)
        Resume StartProg

StartProg:
        On Error GoTo 0
        lblStatus.Text = "Status: Ready"
        Me.Text = Application.ProductName & " V" & Application.ProductVersion

        Dim mNIDLibHandle As IntPtr

        Dim testptr As Long



        'OpenLib 
        RetValue = openNIDLibRD(Application.StartupPath & "\RDNIDLib.DLX")


        testptr = mNIDLibHandle

        If RetValue < 0 Then
            lblStatus.Text = "Status: Error " & RetValue
            MessageBox.Show("Error: " & RetValue, ProductName)
        End If

        'Get Software Info
        Dim FNString As String
        FNString = Space(1024)
        RetValue = getSoftwareInfoRD(FNString)
        If Len(FNString) > 0 Then FNString = VB.Left(FNString, Len(Trim(FNString)) - 1) 'Remove tail of space and null
        m_lblSoftwareInfo.Text = "RDNIDLib Info: " & FNString

        'Get License Info
        FNString = Space(1024)
        RetValue = getLicenseInfoRD(FNString)
        If Len(FNString) > 0 Then FNString = VB.Left(FNString, Len(Trim(FNString)) - 1) 'Remove tail of space and null
        m_lblDLDInfo.Text = "License Info: " & FNString


        mCbxReaderList_Click(sender, e)

    End Sub

    Private Sub NIDCardMain_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles Me.FormClosing
        'closelib 
        If ReadingFg = True Then
            e.Cancel = True
        Else
            RetValue = closeNIDLibRD()
        End If
    End Sub

    Private Sub mCbxReaderList_Click(sender As Object, e As EventArgs) Handles mCbxReaderList.Click
        Dim rdList As String
        Dim size As Integer

        mCbxReaderList.Items.Clear()
        mCbxReaderList.Text = Nothing                              'Clear text in the box

        'getReaderList
        ReaderNameString = Space(1024 * 2)
        size = Len(ReaderNameString)
        ReaderNum = getReaderListRD(ReaderNameString, size)
        rdList = Trim(ReaderNameString)

        If ReaderNum > 0 Then
            ReaderNameString = ReaderNameString & ";"
            ReaderList = Split(ReaderNameString, ";")
            mCbxReaderList.Items.Clear()
            Dim i As Integer
            For i = 0 To ReaderNum - 1
                mCbxReaderList.Items.Add(ReaderList(i))
            Next i
            mCbxReaderList.SelectedIndex = 0
        End If
    End Sub

    Dim SpeedReadText As Stopwatch
    Dim SpeedReadAll As Stopwatch

    Private Sub readCard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles readCard.Click
        Dim iselectReader As Integer
        lblStatus.Text = "Status: Reading..."
        lblTime.Text = ""

        SpeedReadAll = New Stopwatch()
        SpeedReadText = New Stopwatch()

        SpeedReadAll.Start()
        SpeedReadText.Start()


        If ReadingFg = True Then
            GoTo EndSubExit
        End If
        ReadingFg = True
        lblStatus.Text = "Status: Reading..."
        SNID.Text = ""
        STName.Text = ""
        SEName.Text = ""
        SAddress.Text = ""
        SBDATE.Text = ""
        SGender.Text = ""
        SIDate.Text = ""
        SXDate.Text = ""
        SIPlace.Text = ""
        SINum.Text = ""
        SPhoto.Image = Nothing                     'Claer photo
        Me.Refresh()                               'Refresh screen

        'selectReader
        Dim strReader As String = mCbxReaderList.GetItemText(mCbxReaderList.SelectedItem)

        CardObj = selectReaderRD(strReader)
        If CardObj < 0 Then
            lblStatus.Text = "Status: Error " & CardObj
            MessageBox.Show("Error: " & CardObj, ProductName)
            GoTo EndSubClearFg
        End If

        'connectCardRD
        RetValue = connectCardRD(CardObj)
        If RetValue < 0 Then
            lblStatus.Text = "Status: Error " & RetValue
            MessageBox.Show("Error: " & RetValue, ProductName)
            GoTo EndSubClearFg
        End If

        'getNIDText
        Dim DataBuf As String
        Dim size As Integer
        DataBuf = Space(1024)

        RetValue = getNIDTextRD(CardObj, DataBuf, size)
        If RetValue <> 0 Then
            lblStatus.Text = "Status: Error " & RetValue
            MessageBox.Show("Error: " & RetValue, ProductName)
            GoTo EndSubClearFg
        End If

        SpeedReadText.Stop()

        DataBuf = VB.Left(DataBuf, Len(Trim(DataBuf)) - 1) 'Remove tail of space and null

        AllCardData = Trim(DataBuf)
        Dim CardData() As String
        CardData = Split(AllCardData, "#")

        CardNIDNum = CardData(NID_CODE)
        SNID.Text = CardNIDNum
        If CardNIDNum = "" Then
            lblStatus.Text = "Status: Read Text error"
            MessageBox.Show("Read Text error", ProductName)
            GoTo CloseEndSub
        Else
            STName.Text = CardData(Title_T) & " " &
                         CardData(Name_T) & " " &
                         CardData(MidName_T) & " " &
                         LTrim(RTrim(CardData(Surname_T))) 'Remove Space
            SEName.Text = CardData(Title_E) & " " &
                         CardData(Name_E) & " " &
                         CardData(MidName_E) & " " &
                         LTrim(RTrim(CardData(Surname_E))) 'Remove Space
            SAddress.Text = CardData(Home_No) & " " &
                            CardData(Moo) & " " &
                            CardData(Trok) & " " &
                            CardData(Soi) & " " &
                            CardData(Road) & " " &
                            CardData(Tumbon) & " " &
                            CardData(Amphoe) & " " & LTrim(RTrim(CardData(Province))) 'Remove Space

            SBDATE.Text = _yyyymmdd_(CardData(Birth_Date))

            Dim txtGender As String
            If CardData(Gender) = "1" Then
                txtGender = "ชาย"
            ElseIf CardData(Gender) = "2" Then
                txtGender = "หญิง"
            End If

            SGender.Text = txtGender

            SIDate.Text = _yyyymmdd_(CardData(Issue_Date))
            SXDate.Text = _yyyymmdd_(CardData(Expiry_Date))
            SIPlace.Text = LTrim(RTrim(CardData(Issue_Place))) 'Remove Space
            SINum.Text = CardData(Issue_Num)

            'getNIDPhoto
            Dim imgBuf As String
            Dim imgsize As Integer

            imgsize = 1024 * 5
            imgBuf = Space(imgsize)
            RetValue = getNIDPhotoRD(CardObj, imgBuf, imgsize)
            If RetValue <> 0 Then
                lblStatus.Text = "Status: Reading error!"
                MessageBox.Show("Error: " & RetValue, ProductName)
                GoTo EndSubClearFg
            End If

            SpeedReadAll.Stop()

            lblTime.Text = String.Format("Read Text: {0} s, Text + Photo: {1} s", SpeedReadText.Elapsed.TotalSeconds.ToString("f2"), SpeedReadAll.Elapsed.TotalSeconds.ToString("f2"))


            PhotoData = imgBuf
            If PhotoData = "" Then
                lblStatus.Text = "Status: Read Photo error"
                MessageBox.Show("Status: Read Photo error ", ProductName)
                GoTo CloseEndSub
            Else
                RetValue = writeFile(PhotoData, "nidphoto.jpg")
                If RetValue <> -1 Then
                    Dim fs As IO.FileStream                     'Use FileStream for Image buffer
                    fs = New IO.FileStream("nidphoto.jpg",
                                      IO.FileMode.Open, IO.FileAccess.Read)     'Read Photo to buffer
                    SPhoto.Image = Image.FromStream(fs)    'Copy Photo to PictureBox1
                    fs.Close()                             'Close FileStream-buffer     
                End If
            End If
            lblStatus.Text = "Status: Ready"
        End If

CloseEndSub:
        RetValue = disconnectCardRD(CardObj)    ' Close isCardInsertRD, V0.1.2006
        RetValue = deselectReaderRD(CardObj)    ' Close selectReaderRD, V0.1.2006, required for DLL V2.00.006

EndSubClearFg:
        ReadingFg = False

EndSubExit:

    End Sub

    Private Sub loadLIC_Click(ByVal sender As Object, ByVal e As EventArgs) Handles loadLIC.Click
        lblStatus.Text = "Status: Downloading..."
        Me.Refresh()
        Dim MsgErr As String
        Dim UploadReturn As Integer

        lblTime.Text = ""

        'updateLicenseFile
        RetValue = updateLicenseFileRD(Application.StartupPath & "\RDNIDLib.DLX")
        UploadReturn = RetValue

        MsgErr = ""
        If RetValue < 0 Then
            lblStatus.Text = "Status: Error " & RetValue
            MessageBox.Show("Error: " & RetValue, ProductName)
        Else

            'ReOpenlib After updateLicenseFile For Update DLX Info.
            'If the Library is opened Please close Library first.

            'closelib.
            RetValue = closeNIDLibRD()

            'ReOpenLib 
            RetValue = openNIDLibRD(Application.StartupPath & "\RDNIDLib.DLX")
            MsgErr = ""
            If RetValue < 0 Then
                lblStatus.Text = "Status: Error " & RetValue
                MessageBox.Show("Error: " & RetValue, ProductName)
            End If

            'Re Get DLX Info.
            Dim FNString As String
            FNString = Space(1024)
            RetValue = getLicenseInfoRD(FNString)
            If Len(FNString) > 0 Then FNString = Microsoft.VisualBasic.Left(FNString, Len(Trim(FNString)) - 1) 'Remove tail of space and null
            m_lblDLDInfo.Text = "License Info: " & FNString & " (" & UploadReturn & ")"
            lblStatus.Text = "Status: Ready"
        End If


    End Sub

    Private Sub clear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles clear.Click
        lblTime.Text = ""
        SNID.Text = ""
        STName.Text = ""
        SEName.Text = ""
        SAddress.Text = ""
        SBDATE.Text = ""
        SGender.Text = ""
        SIDate.Text = ""
        SXDate.Text = ""
        SIPlace.Text = ""
        SINum.Text = ""
        SPhoto.Image = Nothing                     'Claer photo
        Me.Refresh()                               'Refresh screen                            'Refresh screen
    End Sub

    Private Sub mCbxReaderList_SelectedValueChanged(sender As Object, e As EventArgs) Handles mCbxReaderList.SelectedValueChanged
        lblTime.Text = ""
        SNID.Text = ""
        STName.Text = ""
        SEName.Text = ""
        SAddress.Text = ""
        SBDATE.Text = ""
        SGender.Text = ""
        SIDate.Text = ""
        SXDate.Text = ""
        SIPlace.Text = ""
        SINum.Text = ""

        SPhoto.Image = Nothing                     'Claer photo
        Me.Refresh()                               'Refresh screen
    End Sub
End Class
